/**
 * Die Klasse Subject definiert Methoden, mit denen sich Observer sich
 * registrieren und deregistrieren lassen knnen. Tritt eine 
 * Zustandsnderung auf, wird bei allen registrierten Observern die update-
 * Methode aufgerufen.
 * Ein konkretes Subjekt wir aus Subject abgeleitet (oder verwendet ein 
 * Subject-Object per Delegation) und ruft nach jeder Zustandsnderung 
 * fireUpdate auf. Dadurch werden alle registrierten Beobachter aufgerufen
 * und knnen auf die Zustandsnderung reagieren.
 * --> das konkrete zu beobachtende Subjekt ist hier der Zentralrechner
 */

import java.util.*;

class Subject {
	Vector observers = new Vector();

	public void attach(Observer observer) {
		observers.add(observer);
	}

	public void detach(Observer observer) {
		for (int i = 0; i < observers.size(); ++i) {
			if (observers.get(i) == observer) {
				observers.remove(i);
				break;
			}
		}
	}

	public void fireUpdate() {
		for (int i = 0; i < observers.size(); i++) {
			Observer o = (Observer) observers.get(i);
			o.update(this);
		}
	}
}